﻿using System;
using System.ComponentModel;
using System.Data;
using System.Linq;
using System.Windows.Forms;
using static PROS_Event_Client_Demo.modFunctions;

namespace PROS_Event_Client_Demo
{
    public partial class frmUsers : Form
    {
        #region "Variables"
        internal System.Data.DataRow rowUserSelected;
        bool blnFormLoaded;
        private int _intUserType;
        #endregion
        #region "Load"
        public frmUsers(int intUserType)
        {
            InitializeComponent();
            _intUserType = intUserType;
        }

        private void frmUsers_Load(object sender, EventArgs e)
        {
            if (_intUserType == (int)UserTypes.NormalUser)
                gbFunction.Visible = false;
            Cursor = Cursors.Default;
            subLoadUsers();
        }
        #endregion
        private void subLoadUsers()
        {
            try
            {
                string strUsersQuery = "";
                blnFormLoaded = false;
                dgvUsers.Rows.Clear();
                switch (_intUserType)
                {
                    case (int)UserTypes.NormalUser:
                        strUsersQuery = "(FCard IN (0, 86))";
                        break;
                    case (int)UserTypes.FunctionCards:
                        strUsersQuery = "(FCard IN (173, 202, 234, 240))";
                        break;
                }
                foreach (DataRow row in frmMain.PROSClient.gdtUsers.Select(strUsersQuery))
                {
                    dgvUsers.Rows.Add(row["Name"].ToString());
                    dgvUsers.Rows[dgvUsers.Rows.Count - 1].Tag = row["RedBr"].ToString();
                }
                dgvUsers.Sort(dgvUsers.Columns[0], ListSortDirection.Ascending);
                blnFormLoaded = true;
                dgvUsers_CellEnter(null, null);
            }
            catch (Exception ex)
            {
                System.Diagnostics.Debug.Print(DateTime.Now.TimeOfDay.ToString() + " Error in frmUsers/subLoadUsers: " + ex.Message);
            }
        }
        private void dgvUsers_CellEnter(object sender, System.Windows.Forms.DataGridViewCellEventArgs e)
        {
            if (!blnFormLoaded)
                return;
            if (dgvUsers.Rows.Count == 0)
            {
                switch (_intUserType)
                {
                    case (int)UserTypes.NormalUser:
                        lblDepartmentName.Text = "";
                        picFoto.Image = null;
                        break;
                }
                txtName.Clear();
            }
            else
            {
                rowUserSelected = frmMain.PROSClient.gdtUsers.Rows.Find(Convert.ToInt32(dgvUsers.CurrentRow.Tag));
                txtName.Text = rowUserSelected["Name"].ToString();

                txtID.Text = rowUserSelected["ID"].ToString();
                if (txtID.Text.Length == 0)
                    txtID.Text = "0";
                txtID1.Text = rowUserSelected["ID1"].ToString();
                if (txtID1.Text.Length == 0)
                    txtID1.Text = "0";
                txtID2.Text = rowUserSelected["ID2"].ToString();
                if (txtID2.Text.Length == 0)
                    txtID2.Text = "0";
                txtID3.Text = rowUserSelected["ID3"].ToString();
                if (txtID3.Text.Length == 0)
                    txtID3.Text = "0";
                lblDateFrom.Text = Convert.ToDateTime(rowUserSelected["Start"]).ToString();
                lblDateTo.Text = Convert.ToDateTime(rowUserSelected["Stop"]).ToString();

                switch (_intUserType)
                {
                    case (int)UserTypes.NormalUser:
                        DataRow rowD = frmMain.PROSClient.gdtDepartments.Rows.Find(Convert.ToInt32(rowUserSelected["Department"]));
                        if (rowD == null)
                            lblDepartmentName.Text = "";
                        else
                            lblDepartmentName.Text = rowD["Name"].ToString();
                        if ((rowUserSelected["Foto"]).Equals(DBNull.Value))
                        {
                            picFoto.Image = null;
                        }
                        else
                        {
                            picFoto.Image = fnImageFromBytes((byte[])(rowUserSelected["Foto"]));
                        }
                        foreach (TextBox txtX in gbTabDetails.Controls.OfType<TextBox>())
                        {
                            txtX.Text = rowUserSelected[txtX.Name].ToString();
                        }

                        foreach (TextBox txtX in gbTabDetails2.Controls.OfType<TextBox>())
                        {
                            txtX.Text = rowUserSelected[txtX.Name].ToString();
                        }

                        break;
                    case (int)UserTypes.FunctionCards:
                        foreach (RadioButton rb in gbFunction.Controls.OfType<RadioButton>())
                        {
                            if (Convert.ToInt32(rb.Tag) == Convert.ToInt32(rowUserSelected["FCard"]))
                            {
                                rb.Checked = true;
                                break; 
                            }
                        }

                        break;
                }

            }
        }

    }
}
